<!doctype html>
<html lang="en">
<head>
    <title>Code coverage report for modules/persistence.js</title>
    <meta charset="utf-8" />
    <link rel="stylesheet" href="../prettify.css" />
    <link rel="stylesheet" href="../base.css" />
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <style type='text/css'>
        .coverage-summary .sorter {
            background-image: url(../sort-arrow-sprite.png);
        }
    </style>
</head>
<body>
<div class='wrapper'>
  <div class='pad1'>
    <h1>
      <a href="../index.html">all files</a> / <a href="index.html">modules/</a> persistence.js
    </h1>
    <div class='clearfix'>
      <div class='fl pad1y space-right2'>
        <span class="strong">7.22% </span>
        <span class="quiet">Statements</span>
        <span class='fraction'>7/97</span>
      </div>
      <div class='fl pad1y space-right2'>
        <span class="strong">0% </span>
        <span class="quiet">Branches</span>
        <span class='fraction'>0/40</span>
      </div>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Functions</span>
        <span class='fraction'>0/0</span>
      </div>
      <div class='fl pad1y space-right2'>
        <span class="strong">7.37% </span>
        <span class="quiet">Lines</span>
        <span class='fraction'>7/95</span>
      </div>
    </div>
  </div>
  <div class='status-line low'></div>
<pre><table class="coverage">
<tr><td class="line-count quiet">1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169</td><td class="line-coverage quiet"><span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-no">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span></td><td class="text"><pre class="prettyprint lang-js">&nbsp;
'use strict'
&nbsp;
/**
Used to handle data persistence.
 * @module persistence
 */
&nbsp;
const schema = require('../schema/schema')
const bcrypt = require('bcryptjs')
&nbsp;
/** Checks to see if the supplied credentials are valid.
 * @function search
 * @param {Object} credentials the credentials object passed by the API
 * @param {Function(Error, String)} callback run on completion
 */
exports.validCredentials = (credentials, callback) =&gt; {
<span class="cstat-no" title="statement not covered" >	if (credentials.username === undefined || credentials.password === undefined)</span>
<span class="cstat-no" title="statement not covered" >		callback(new Error('missing username and/or password'))</span>
<span class="cstat-no" title="statement not covered" >	schema.User.find({username: credentials.username}, (err, docs) =&gt; {</span>
<span class="cstat-no" title="statement not covered" >		if (err) <span class="cstat-no" title="statement not covered" >callback(err)</span></span>
<span class="cstat-no" title="statement not covered" >		if (docs.length === 0) <span class="cstat-no" title="statement not covered" >callback(null, false)</span></span>
<span class="cstat-no" title="statement not covered" >		console.log(docs[0])</span>
		// need to test hash library
		// const saltStrength = 10
		// const salt = bcrypt.genSaltSync(saltStrength)
		// const pw = bcrypt.hashSync(credentials.password, salt)
		// console.log(`pw: ${pw}`)
		// end test
<span class="cstat-no" title="statement not covered" >		console.log(`docs[0].password: ${docs[0].password}`)</span>
<span class="cstat-no" title="statement not covered" >		console.log(`credentials.password: ${credentials.password}`)</span>
<span class="cstat-no" title="statement not covered" >		if (!bcrypt.compareSync(credentials.password, docs[0].password)) {</span>
<span class="cstat-no" title="statement not covered" >			console.log('passwords dont match')</span>
<span class="cstat-no" title="statement not covered" >			callback(null, false)</span>
<span class="cstat-no" title="statement not covered" >			return</span>
		}
<span class="cstat-no" title="statement not covered" >		console.log('valid credentials')</span>
<span class="cstat-no" title="statement not covered" >		callback(null, true)</span>
	})
}
&nbsp;
/** Checks to see if the supplied credentials are valid.
 * @function validUsername
 * @param {Object}                  credentials the credentials object passed by the API
 * @param {Function(Error, String)} callback    run on completion
 */
exports.validUsername = (credentials, callback) =&gt; {
<span class="cstat-no" title="statement not covered" >	if (credentials.username === undefined) {</span>
<span class="cstat-no" title="statement not covered" >		callback(new Error('missing username'))</span>
<span class="cstat-no" title="statement not covered" >		return</span>
	}
<span class="cstat-no" title="statement not covered" >	schema.User.find({username: credentials.username}, (err, docs) =&gt; {</span>
<span class="cstat-no" title="statement not covered" >		if (err) {</span>
<span class="cstat-no" title="statement not covered" >			callback(err)</span>
<span class="cstat-no" title="statement not covered" >			return</span>
		}
<span class="cstat-no" title="statement not covered" >		console.log(docs)</span>
<span class="cstat-no" title="statement not covered" >		if (docs.length === 0) {</span>
<span class="cstat-no" title="statement not covered" >			console.log('no matching username')</span>
<span class="cstat-no" title="statement not covered" >			callback(null, false)</span>
<span class="cstat-no" title="statement not covered" >			return</span>
		}
<span class="cstat-no" title="statement not covered" >		callback(null, true)</span>
	})
}
&nbsp;
/** Adds a new user account.
 * @function addAccount
 * @param {Object} credentials the credentials object passed by the API
 * @param {Object} user the additional user details (name)
 * @param {Function(Error, String)} callback run on completion
 */
exports.addAccount = (credentials, user, callback) =&gt; {
<span class="cstat-no" title="statement not covered" >	console.log('addAccount')</span>
<span class="cstat-no" title="statement not covered" >	console.log(credentials)</span>
<span class="cstat-no" title="statement not covered" >	if (credentials.username === undefined || credentials.password === undefined) {</span>
<span class="cstat-no" title="statement not covered" >		callback(new Error('missing username and/or password'))</span>
<span class="cstat-no" title="statement not covered" >		return</span>
	}
<span class="cstat-no" title="statement not covered" >	if (user.name === undefined) {</span>
<span class="cstat-no" title="statement not covered" >		callback(new Error('missing name'))</span>
<span class="cstat-no" title="statement not covered" >		return</span>
	}
<span class="cstat-no" title="statement not covered" >	let account = undefined</span>
<span class="cstat-no" title="statement not covered" >	try {</span>
<span class="cstat-no" title="statement not covered" >		user.username = credentials.username</span>
<span class="cstat-no" title="statement not covered" >		const saltStrength = 10</span>
<span class="cstat-no" title="statement not covered" >		const salt = bcrypt.genSaltSync(saltStrength)</span>
<span class="cstat-no" title="statement not covered" >		user.password = bcrypt.hashSync(credentials.password, salt)</span>
<span class="cstat-no" title="statement not covered" >		account = new schema.User(user)</span>
	} catch(err) {
<span class="cstat-no" title="statement not covered" >		callback(err)</span>
<span class="cstat-no" title="statement not covered" >		return</span>
	}
<span class="cstat-no" title="statement not covered" >	account.save( (err, data) =&gt; {</span>
<span class="cstat-no" title="statement not covered" >		if (err) {</span>
<span class="cstat-no" title="statement not covered" >			callback(new Error('error creating account'))</span>
<span class="cstat-no" title="statement not covered" >			return</span>
		}
<span class="cstat-no" title="statement not covered" >		const user = {name: data.name, username: data.username}</span>
<span class="cstat-no" title="statement not covered" >		callback(null, user)</span>
	})
}
&nbsp;
/** Adds a book to the user's shopping cart.
 * @function addBookToCart
 * @param {Object}                  credentials the credentials object passed by the API
 * @param {Object}                  bookDetails the details of the book to add
 * @param {Function(Error, String)} callback    run on completion
 */
exports.addBook = (credentials, bookDetails, callback) =&gt; {
<span class="cstat-no" title="statement not covered" >	if (credentials.username === undefined) {</span>
<span class="cstat-no" title="statement not covered" >		callback(new Error('missing username'))</span>
<span class="cstat-no" title="statement not covered" >		return</span>
	}
<span class="cstat-no" title="statement not covered" >	console.log(`username supplied: ${credentials.username}`)</span>
<span class="cstat-no" title="statement not covered" >	console.log(bookDetails)</span>
<span class="cstat-no" title="statement not covered" >	bookDetails.account = credentials.username</span>
<span class="cstat-no" title="statement not covered" >	const book = new schema.Book(bookDetails)</span>
<span class="cstat-no" title="statement not covered" >	book.save( (err, savedBook) =&gt; {</span>
<span class="cstat-no" title="statement not covered" >		if (err) {</span>
<span class="cstat-no" title="statement not covered" >			callback(err)</span>
<span class="cstat-no" title="statement not covered" >			return</span>
		}
<span class="cstat-no" title="statement not covered" >		callback(null, savedBook)</span>
	})
}
&nbsp;
/** gets the contents of the user's shopping cart.
 * @function addBookToCart
 * @param {Object}                  credentials the credentials object passed by the API
 * @param {Function(Error, String)} callback    run on completion
 */
exports.getBooksInCart = (credentials, callback) =&gt; {
<span class="cstat-no" title="statement not covered" >	if (credentials.username === undefined || credentials.password === undefined) {</span>
<span class="cstat-no" title="statement not covered" >		callback(new Error('missing username and/or password'))</span>
<span class="cstat-no" title="statement not covered" >		return</span>
	}
<span class="cstat-no" title="statement not covered" >	this.validCredentials(credentials, (err, data) =&gt; {</span>
<span class="cstat-no" title="statement not covered" >		if (err) {</span>
<span class="cstat-no" title="statement not covered" >			callback(err)</span>
<span class="cstat-no" title="statement not covered" >			return</span>
		}
<span class="cstat-no" title="statement not covered" >		if (data === false) {</span>
<span class="cstat-no" title="statement not covered" >			callback(new Error('invalid credentials'))</span>
<span class="cstat-no" title="statement not covered" >			return</span>
		}
<span class="cstat-no" title="statement not covered" >		console.log('a')</span>
<span class="cstat-no" title="statement not covered" >		schema.Book.find({account: credentials.username}, (err, docs) =&gt; {</span>
<span class="cstat-no" title="statement not covered" >			console.log('b')</span>
<span class="cstat-no" title="statement not covered" >			if (err) {</span>
<span class="cstat-no" title="statement not covered" >				console.log('c')</span>
<span class="cstat-no" title="statement not covered" >				callback(err)</span>
<span class="cstat-no" title="statement not covered" >				return</span>
			}
<span class="cstat-no" title="statement not covered" >			console.log('d')</span>
<span class="cstat-no" title="statement not covered" >			console.log(docs.constructor)</span>
<span class="cstat-no" title="statement not covered" >			console.log(`docs.length: ${docs.length}`)</span>
<span class="cstat-no" title="statement not covered" >			if (docs.length &lt; 1) {</span>
<span class="cstat-no" title="statement not covered" >				console.log('e')</span>
<span class="cstat-no" title="statement not covered" >				callback(new Error('shopping cart empty'))</span>
<span class="cstat-no" title="statement not covered" >				return</span>
			}
<span class="cstat-no" title="statement not covered" >			console.log('f')</span>
<span class="cstat-no" title="statement not covered" >			callback(null, docs)</span>
		})
	})
}
&nbsp;</pre></td></tr>
</table></pre>
<div class='push'></div><!-- for sticky footer -->
</div><!-- /wrapper -->
<div class='footer quiet pad2 space-top1 center small'>
  Code coverage
  generated by <a href="http://istanbul-js.org/" target="_blank">istanbul</a> at Sun Jul 02 2017 10:35:44 GMT+0100 (BST)
</div>
</div>
<script src="../prettify.js"></script>
<script>
window.onload = function () {
        if (typeof prettyPrint === 'function') {
            prettyPrint();
        }
};
</script>
<script src="../sorter.js"></script>
</body>
</html>
